



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】EF Code First 学习笔记:约定配置</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】EF Code First 学习笔记:约定配置</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:50:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>要更改EF中的默认配置有两个方法，一个是用Data Annotations(在命名空间System.ComponentModel.DataAnnotations;)，直接作用于类的属性上面;还有一个就是Fluent API，通过新增相应的配置类来覆盖默认配置。现在我们用这两个来对比了解EF中的约定配置。</p>
<p><strong>主键：KEY</strong></p>
<p>Data Annotations：通过Key关键字来标识一个主键</p>
<div>
<pre class="prettyprint linenums">[Key]<br />
public int DestinationId { get; set; }</pre>
</div>
<p>Fluent API：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class BreakAwayContext : DbContext<br />
    {<br />
        public DbSet&lt;Destination&gt; Destinations { get; set; }<br />
        public DbSet&lt;Lodging&gt; Lodgings { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)<br />
        {<br />
            //Fluent API<br />
            modelBuilder.Entity&lt;Destination&gt;().HasKey(d =&gt; d.DestinationId);<br />
            base.OnModelCreating(modelBuilder);<br />
        }<br />
    } </pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>外键</strong></p>
<p>Data Annotations：</p>
<div>
<pre class="prettyprint linenums">        public int DestinationId { get; set; }<br />
        [ForeignKey("DestinationId")]<br />
        public Destination Destination { get; set; }</pre>
</div>
<p>注意，指定列名存在，如上面的DestinationId，则类中必须存在名称为DestinationId的属性。</p>
<p>Fluent API：</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Lodging&gt;().HasRequired(p =&gt; p.Destination).WithMany(p=&gt;p.Lodgings).HasForeignKey(p =&gt; p.DestinationId);</pre>
</div>
<p><strong>长度</strong></p>
<p>Data Annotations：通过StringLength(长度),MinLength(最小长度),MaxLength(最大长度)来设置数据库中字段的长度。</p>
<div>
<pre class="prettyprint linenums">        [MinLength(10),MaxLength(30)]<br />
        public string Name { get; set; }<br />
        [StringLength(30)]<br />
        public string Country { get; set; }</pre>
</div>
<p>Fluent API：没有设置最小长度这个方法。</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Destination&gt;().Property(p =&gt; p.Name).HasMaxLength(30);<br />
            modelBuilder.Entity&lt;Destination&gt;().Property(p =&gt; p.Country).HasMaxLength(30);</pre>
</div>
<p><strong>非空</strong></p>
<p>Data Annotations：用Required来标识，还可以设置是否可允许空字符串，显示错误消息等。</p>
<div>
<pre class="prettyprint linenums">        [Required]<br />
        public string Country { get; set; }<br />
        [Required(ErrorMessage="请输入描述")]<br />
        public string Description { get; set; }</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Destination&gt;().Property(p =&gt; p.Country).IsRequired();</pre>
</div>
<p><strong>数据类型</strong></p>
<p>Data Annotations：TypeName</p>
<div>
<pre class="prettyprint linenums">//将string映射成ntext，默认为nvarchar(max)<br />
        [Column(TypeName = "ntext")]<br />
        public string Owner { get; set; }</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Lodging&gt;().Property(p =&gt; p.Owner).HasColumnType("ntext");</pre>
</div>
<p><strong>表名</strong></p>
<p>Data Annotations：Table</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">[Table("MyLodging")]<br />
    public class Lodging<br />
    {<br />
        public int LodgingId { get; set; }<br />
        public string Name { get; set; }<br />
        public string Owner { get; set; }<br />
        public decimal Price { get; set; }<br />
        public bool IsResort { get; set; }<br />
        public Destination Destination { get; set; }

    } </pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Lodging&gt;().ToTable("MyLodging");</pre>
</div>
<p><strong>列名</strong></p>
<p>Data Annotations：Column</p>
<div>
<pre class="prettyprint linenums">[Column("MyName")]<br />
public string Name { get; set; }</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Lodging&gt;().Property(p =&gt; p.Name).HasColumnName("MyName");</pre>
</div>
<p><strong>自增长</strong></p>
<p>如果主键是int类型，EF为默认设置为增长。但如果是GUID类型，则要显示的设置自增长。</p>
<p>Data Annotations：DatabaseGenerated</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">  public class Person<br />
    {<br />
        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]<br />
        public Guid SocialId { get; set; }<br />
        public string FirstName { get; set; }<br />
        public string LastName { get; set; }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>看看创建数据的脚本，会加一句</p>
<div>
<pre class="prettyprint linenums">ALTER TABLE [dbo].[People] ADD  DEFAULT (newid()) FOR [SocialId]</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Person&gt;().Property(p =&gt; p.SocialId).HasDatabaseGeneratedOption(DatabaseGeneratedOption.Identity);</pre>
</div>
<p><strong>忽略列映射</strong></p>
<p>类中有些属性，特别是一些通过计算或合并列得出的结果，我们并不需要其记录到数据库中，就可以通过配置不让它生成在数据库中。</p>
<p>Data Annotations：NotMapped</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">        [NotMapped]<br />
        public string Name<br />
        {<br />
            get<br />
            {<br />
                return FirstName + " " + LastName;<br />
            }<br />
        }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>Fluent API:NotMapped</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Person&gt;().Ignore(p =&gt; p.Name);</pre>
</div>
<p><strong>忽略表映射</strong></p>
<p>对于不需要映射到数据库中的表，我们也可以取消其映射。</p>
<p>Data Annotations：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> [NotMapped]<br />
    public class Person<br />
    {<br />
        [Key]<br />
        public Guid SocialId { get; set; }<br />
        public string FirstName { get; set; }<br />
        public string LastName { get; set; }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Ignore&lt;Person&gt;();</pre>
</div>
<p><strong>时间戳</strong></p>
<p>时间戳只对数据类型为byte[]的属性有效，并且一个类中只能有一个设置为时间戳的属性。</p>
<p>Data Annotations：Timestamp</p>
<div>
<pre class="prettyprint linenums">    [Timestamp]<br />
    public Byte[] TimeStamp { get; set; }</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.Entity&lt;Lodging&gt;().Property(p =&gt; p.TimeStamp).IsRowVersion();</pre>
</div>
<p><strong>复杂类型</strong></p>
<p>Data Annotations：ComplexType</p>
<div>
<pre class="prettyprint linenums"> [ComplexType]<br />
    public class Address<br />
    {<br />
        public string Country { get; set; }<br />
        public string City { get; set; }<br />
    }</pre>
</div>
<p>Fluent API:</p>
<div>
<pre class="prettyprint linenums">modelBuilder.ComplexType&lt;Address&gt;();</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39ryw6r8.html">HTML5--拖动02-dragstart、drag、dragenter、dragover、dragleave、drop、dragend属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r0mg79.html">&lbrack;原创&rsqb;C&num;引用C&plus;&plus;编译的dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvndky9.html">Linux&lowbar;Shell&lowbar;输出重定向</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4gvj9.html">Nginx个人简单理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdvev0q.html">学习使用vim，熟悉Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wddyq.html">WP8&period;1 Study18&colon;动态磁贴</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw3dyz9.html">Android、iOS和Windows Phone中的推送技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdwon48.html">CATextLayer</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpvloq.html">Canvas Path 绘制柱体</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpn3639.html">java byte【】数组与文件读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4gjm8.html">献身说法---修复bug时的一些小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zre4e9.html">【题解】P1171 售货员的难题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljyn019.html">网络基础之HTTP、TCP&sol;IP、Socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rm7458.html">SpringBoot配置ActiveMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1wvr9.html">goland scope pattern 设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrn6n9.html">Js中处理日期加减天数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgyn78.html">PHP----------安装包lnmp1&period;3-full安装的lnmp环境，如何安装PHP扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j626jq.html">Scrum敏捷开发沉思录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwywyy8.html">C&num; TextBox猜想输入和历史记录输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve527z9.html">用python实现MRO算法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e4v57j9.html">NSHashTable NSPointerArray</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7orl5g8.html">vnode的挂载和更新流程 -- 简介&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdv55d9.html">Python 再次改进版通过队列实现一个生产者消费者模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyw6e19.html">phpStrom--我常用的快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gozymq.html">python 实现图的深度优先和广度优先搜索</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll4wd6q.html">Python学习笔记第八周</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r3w5z8.html">jsp-servlet（2）响应HTML文档-书籍管理系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rgklm9.html">FreeModbus LINUXTCP Compile ERROR</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1e21pq.html">NOI-1&period;1-06-空格分隔输出-体验多个输入输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7orjl18.html">aliyun服务器对象存储oss</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
